//Help functions for tests

#ifndef HELPER_H_INCLUDED
#define HELPER_H_INCLUDED

#include <iostream>
#include <limits> //std::numeric_limits

//C++20 or higher
#if __cplusplus >= 202002L
#include <concepts>
template<typename T>
concept Streamables = requires(T t){std::cin >> t;};

//Get from std::cin true data
//---------------------------
//(by material of site
//https://www.learncpp.com/cpp-tutorial/stdcin-and-handling-invalid-input/
//see getDouble() example)
template<Streamables Streamable_t>
#else
template<typename Streamable_t>
#endif // __cplusplus
Streamable_t request_cin(const char* request)
{
    while( true ) // Loop until user enters a valid input
    {
        std::cout << request;
        Streamable_t x{};
        std::cin >> x;

        if( !std::cin ) // If the previous extraction failed
        {
            // Let's handle the failure
            std::cin.clear(); // Put us back in 'normal' operation mode
            std::cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
            // And remove the bad input
            continue;
        }
        // Our extraction succeeded

        std::cin.ignore(std::numeric_limits<std::streamsize>::max(), '\n');
        // Ignore any additional input on this line

        return x; // Return the value we extracted

    }
}

bool request_repeate()
{
    char go{'\0'};
    while( true )
    {
        std::cout << "\nRepeate? [1 for 'Yes' / 0 for 'No']: ";
        std::cin >> go;
        if( ('0' == go) || ('1' == go) )
            break;
    }

    return ( '1' == go );
}


#endif // HELPER_H_INCLUDED
